-- Created from Template Blank Module using VHDL_Entity Editor by Stan Bak

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity input is
	port (
	clock : in std_logic := '0';
	start : in std_logic := '0';
	done : out std_logic := '0';
	iSlope : in signed(15 downto 0) := (others => '0');
	iNextSteering : in signed(15 downto 0) := (others => '0');
	nextVelocity : in signed(15 downto 0) := (others => '0');
	allow : out signed(0 downto 0) := (others => '0')
	);
end input;

architecture Behavioral of input is
	signal slope : signed(15 downto 0) := (others => '0');
	signal nextSteering : signed(15 downto 0) := (others => '0');
	signal fsmState : integer range 0 to 255 := 0;
	signal worstCaseSlope : signed(15 downto 0) := (others => '0');
	signal rightHandSide : signed(31 downto 0) := (others => '0');
	signal leftHandSide : signed(31 downto 0) := (others => '0');
begin

process (clock) begin
if rising_edge(clock) then
case fsmState is
	when 0 =>
		done <= '0';

		if start = '1' then
			fsmState <= 1;
		end if;
	when 1 =>
		if iNextSteering > 0 then
			fsmState <= 52;
		else
			fsmState <= 54;
		end if;
	when 52 =>
		slope <= to_signed(to_integer(iSlope), 16);
		fsmState <= 53;
	when 53 =>
		nextSteering <= to_signed(to_integer(iNextSteering), 16);
		fsmState <= 41;
	when 54 =>
		slope <= to_signed(to_integer(iSlope), 16);
		fsmState <= 55;
	when 55 =>
		slope <= to_signed(to_integer(slope) * (-1), 16);
		fsmState <= 56;
	when 56 =>
		nextSteering <= to_signed(to_integer(iNextSteering), 16);
		fsmState <= 57;
	when 57 =>
		nextSteering <= to_signed(to_integer(nextSteering) * (-1), 16);
		fsmState <= 41;
	when 41 =>
		worstCaseSlope <= slope + (200);
		fsmState <= 42;
	when 42 =>
		if worstCaseSlope > 1000 then
			fsmState <= 43;
		else
			fsmState <= 44;
		end if;
	when 43 =>
		worstCaseSlope <= to_signed(1000, 16);
		fsmState <= 44;
	when 44 =>
		if worstCaseSlope = 600 then
			fsmState <= 7;
		else
			fsmState <= 45;
		end if;
	when 45 =>
		if worstCaseSlope = 800 then
			fsmState <= 8;
		else
			fsmState <= 46;
		end if;
	when 46 =>
		if worstCaseSlope = 1000 then
			fsmState <= 9;
		else
			fsmState <= 10;
		end if;
	when 7 =>
		rightHandSide <= to_signed(to_integer(nextVelocity), 32);
		fsmState <= 12;
	when 12 =>
		rightHandSide <= to_signed(to_integer(rightHandSide) * (51), 32);
		fsmState <= 13;
	when 13 =>
		rightHandSide <= rightHandSide srl (8);
		fsmState <= 14;
	when 14 =>
		rightHandSide <= to_signed(to_integer(rightHandSide) * (-1), 32);
		fsmState <= 15;
	when 15 =>
		rightHandSide <= rightHandSide + (2400);
		fsmState <= 16;
	when 16 =>
		leftHandSide <= to_signed(to_integer(nextSteering), 32);
		fsmState <= 17;
	when 17 =>
		if leftHandSide > rightHandSide then
			done <= '1';
			fsmState <= 0;
		else
			fsmState <= 10;
		end if;
	when 8 =>
		if nextVelocity > 5000 then
			fsmState <= 19;
		else
			fsmState <= 20;
		end if;
	when 19 =>
		if nextSteering < 700 then
			fsmState <= 10;
		else
			done <= '1';
			fsmState <= 0;
		end if;
	when 20 =>
		leftHandSide <= to_signed(to_integer(nextSteering), 32);
		fsmState <= 21;
	when 21 =>
		rightHandSide <= to_signed(to_integer(nextVelocity), 32);
		fsmState <= 22;
	when 22 =>
		rightHandSide <= to_signed(to_integer(rightHandSide) * (146), 32);
		fsmState <= 23;
	when 23 =>
		rightHandSide <= rightHandSide srl (8);
		fsmState <= 24;
	when 24 =>
		rightHandSide <= to_signed(to_integer(rightHandSide) * (-1), 32);
		fsmState <= 25;
	when 25 =>
		rightHandSide <= rightHandSide + (3557);
		fsmState <= 26;
	when 26 =>
		if leftHandSide > rightHandSide then
			done <= '1';
			fsmState <= 0;
		else
			fsmState <= 10;
		end if;
	when 9 =>
		if nextVelocity > 2900 then
			fsmState <= 27;
		else
			fsmState <= 10;
		end if;
	when 27 =>
		if nextSteering > 300 then
			fsmState <= 28;
		else
			fsmState <= 10;
		end if;
	when 28 =>
		leftHandSide <= to_signed(to_integer(nextSteering), 32);
		fsmState <= 29;
	when 29 =>
		rightHandSide <= to_signed(to_integer(nextVelocity), 32);
		fsmState <= 30;
	when 30 =>
		rightHandSide <= to_signed(to_integer(rightHandSide) * (77), 32);
		fsmState <= 31;
	when 31 =>
		rightHandSide <= rightHandSide srl (8);
		fsmState <= 32;
	when 32 =>
		rightHandSide <= to_signed(to_integer(rightHandSide) * (-1), 32);
		fsmState <= 33;
	when 33 =>
		rightHandSide <= rightHandSide + (1770);
		fsmState <= 34;
	when 34 =>
		if leftHandSide > rightHandSide then
			done <= '1';
			fsmState <= 0;
		else
			fsmState <= 10;
		end if;
	when 10 =>
		allow <= to_signed(-1, 1);
		done <= '1';
		fsmState <= 0;
	when others =>
end case;
end if;
end process;
end Behavioral;

