
public class VHDL_Signal 
{
	public String name;
	public String type;
	public SignalDirection direction;
	public String initial;
	
	public static String[] DIRECTION_NAMES = 
	{
		"in", "out", "inout", "internal"
	};
	
	public static SignalDirection[] DIRECTION_INDICIES =
	{
		SignalDirection.IN, SignalDirection.OUT, SignalDirection.INOUT, SignalDirection.INTERNAL
	};
	
	public VHDL_Signal() {}
	
	public VHDL_Signal(String name, String type)
	{
		this.name = name;
		this.type = type;
		this.direction = SignalDirection.INTERNAL;
	}
	
	public VHDL_Signal(String name, String type, SignalDirection direction, String initial)
	{
		this.name = name;
		this.type = type;
		this.direction = direction;
		this.initial = initial;
	}
	
	public String toString()
	{
		return "[VHDL_Signal - " + name + " : " + direction + " " + type + " := " + initial + "]";
	}
}
